Index: /java/FramclipsePlugin/src/main/resources/framscript.xml
===================================================================
--- /java/FramclipsePlugin/src/main/resources/framscript.xml	(revision 327)
+++ /java/FramclipsePlugin/src/main/resources/framscript.xml	(revision 328)
@@ -27,5 +27,5 @@
 	<type name="style" context="style file">
 <description><![CDATA[General visual style properties.]]></description>
-		<element name="style" type="string"/>
+		<element name="style" type="string" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>
@@ -112,5 +112,5 @@
 function onDied(cr) {Simulator.print("Creature "+cr.name+" has died");}
 See also: Population.]]></description>
-		<element name="name" type="string"/>
+		<element name="name" type="string" max="30"/>
 		<element name="genotype" type="string" flags="1"/>
 		<element name="info" type="string">
@@ -394,5 +394,5 @@
 <description><![CDATA[A data object consisting of the same fields as the serialized Creature. Typically used for reading a Creature back from a file, then Population.add(snapshot_object) creates the Creature object from the snapshot.]]></description>
 		<element name="new" function="true" type="Creature"><arguments/></element>
-		<element name="name" type="string"/>
+		<element name="name" type="string" max="30"/>
 		<element name="genotype" type="string"/>
 		<element name="info" type="string">
@@ -1311,5 +1311,5 @@
 			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiWwEeAaSsDdGgBbHh]]></description>
 		</element>
-		<element name="f1_mut_exmod" type="string">
+		<element name="f1_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
 (all: LlRrCcQqFfMmIiWwEeAaSsDdGgBbHh)]]></description>
@@ -1449,5 +1449,5 @@
 <description><![CDATA[All information about a single genotype.
 This is a genetics-only object which does not contain any performance data. See also: Genotype class]]></description>
-		<element name="name" type="string" flags="256"/>
+		<element name="name" type="string" max="40" flags="256"/>
 		<element name="rawgenotype" type="string" flags="257">
 			<description><![CDATA[Genotype, excluding the format specifier]]></description>
@@ -1494,5 +1494,5 @@
 <description><![CDATA[A Genotype with the associated performance information. Adding genotypes to GenePool makes them accessible in Framsticks GUI and enables the use of GenePool selection methods.
 Before version 4.0rc4 the static Genotype object was used in functions operating on the "selected" genotype. This is now deprecated as all operations can be performed using the more convenient direct access (see GenePools).]]></description>
-		<element name="name" type="string"/>
+		<element name="name" type="string" max="40"/>
 		<element name="genotype" type="string"/>
 		<element name="info" type="string">
@@ -1699,5 +1699,5 @@
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="joint"/>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -2227,5 +2227,5 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
@@ -2727,5 +2727,5 @@
 		<element name="rz" type="float" flags="1024"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="part"/>
 		<element name="vs" type="float" min="0.05" max="0.7" default="0.2"/>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
@@ -3244,5 +3244,5 @@
 <arguments/></element>
 		<element name="loadexpdef" function="true" type="void"><arguments/></element>
-		<element name="usercode" type="string" flags="2048">
+		<element name="usercode" type="string" min="1" flags="2048">
 			<description><![CDATA[This script overrides the experiment definition]]></description>
 		</element>
@@ -3815,5 +3815,5 @@
 			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiWwEeAaSsDdGgBbHh]]></description>
 		</element>
-		<element name="f1_mut_exmod" type="string">
+		<element name="f1_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
 (all: LlRrCcQqFfMmIiWwEeAaSsDdGgBbHh)]]></description>
@@ -4393,5 +4393,5 @@
 <arguments/></element>
 		<element name="loadexpdef" function="true" type="void"><arguments/></element>
-		<element name="usercode" type="string" flags="2048">
+		<element name="usercode" type="string" min="1" flags="2048">
 			<description><![CDATA[This script overrides the experiment definition]]></description>
 		</element>
@@ -5126,5 +5126,5 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
@@ -5253,5 +5253,5 @@
 <description><![CDATA[A Genotype with the associated performance information. Adding genotypes to GenePool makes them accessible in Framsticks GUI and enables the use of GenePool selection methods.
 Before version 4.0rc4 the static Genotype object was used in functions operating on the "selected" genotype. This is now deprecated as all operations can be performed using the more convenient direct access (see GenePools).]]></description>
-		<element name="name" type="string"/>
+		<element name="name" type="string" max="40"/>
 		<element name="genotype" type="string"/>
 		<element name="info" type="string">
@@ -5363,5 +5363,5 @@
 function onDied(cr) {Simulator.print("Creature "+cr.name+" has died");}
 See also: Population.]]></description>
-		<element name="name" type="string"/>
+		<element name="name" type="string" max="30"/>
 		<element name="genotype" type="string" flags="1"/>
 		<element name="info" type="string">
@@ -5725,5 +5725,5 @@
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="joint"/>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -5738,5 +5738,5 @@
 	<type name="m" context="Visual style definition">
 		<element name="se" type="float" flags="1024"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1"/>
 	</type>
 	<type name="Material" context="Visual style definition">
@@ -5793,5 +5793,5 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
@@ -5833,5 +5833,5 @@
 		<element name="rz" type="float" flags="1024"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1" default="part"/>
 		<element name="vs" type="float" min="0.05" max="0.7" default="0.2"/>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
@@ -5945,5 +5945,5 @@
 	</type>
 	<type name="VisualStyle" context="Visual style definition">
-		<element name="style" type="string"/>
+		<element name="style" type="string" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>
@@ -6286,8 +6286,8 @@
 	</type>
 	<type name="ImageExport" context="Command line interface">
-		<element name="imgex_outdir" type="string">
+		<element name="imgex_outdir" type="string" default=".">
 			<description><![CDATA[Directory name WITHOUT trailing '/' sign]]></description>
 		</element>
-		<element name="imgex_outfiles" type="string">
+		<element name="imgex_outfiles" type="string" default="scene_38288288.jpg">
 			<description><![CDATA[Frame number replaces %d (eg. 'image%03d.jpg')]]></description>
 		</element>
@@ -6470,5 +6470,5 @@
 	</type>
 	<type name="VisualStyle" context="Command line interface">
-		<element name="style" type="string"/>
+		<element name="style" type="string" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>